#include <stdlib.h>
#include <stdio.h>

#include "linked_list.h"


int main(int argc, char *argv[]) {
  if (argc != 2) {
    printf("Not the right number of arguments\n");
    printf("Usage: %s list_size\n", argv[0]);
    return -1;
  }

  int list_size = atoi(argv[1]);

  if (list_size <= 0) {
    printf("Please provide a list_size > 0\n");
    printf("Usage: %s list_size\n", argv[0]);
    return -2;
  }

  // Create a new list (on the stack) and make sure to intialize!
  llist_t list;
  list.head = NULL;
  list.node_count = 0;

  for (int i=0; i<list_size; i++) {
    // Get new random data
    int data = rand()%1000;

    // Create a new node
    // This has to be done on the heap!
    node_t *node = (node_t*)malloc(sizeof(node_t));

    // MUST initialize data before use!
    node->next = NULL;
    node->data = data;

    int res = add_front(&list, node);
    if (res != 0) {
      printf("Error adding node! Error code: %d\n", res);
      return -3;
    }
  }

  // Let's just print the list and exit.
  // There is much more you could do!
  
  print_list(&list);

  return 0;
}
